//package nux.xom.tests;
//
//import java.io.File;
//import java.io.IOException;
//
//import javax.xml.transform.TransformerException;
//
//import nu.xom.Document;
//import nu.xom.Node;
//import nu.xom.Nodes;
//import nu.xom.ParsingException;
//import nu.xom.ValidityException;
//import nux.xom.pool.BuilderPool;
//import nux.xom.pool.DocumentURIResolver;
//import nux.xom.pool.XOMUtil;
//import nux.xom.xquery.XQuery;
//import bumblebee.Adapter;
//import bumblebee.AdapterException;
//
///**
// * Adapter to run the bumblebee XQuery test suite. 
// * Download at http://www.xquery.com/bumblebee/
// * Steps to test: 
// * 1) Configure the bumblebee.properties file with a line that reads:
// * <pre>
// * bumblebee.adapter.Xom.class=nux.xom.tests.BumblebeeAdapter
// * </pre>
// * 
// * 2) Copy the xom.jar, nux.jar, saxon8.jar files into bumblebee/lib/ext/ 
// * 4) Run bumblebee.sh
// * 5) Examine the log/bumblebee.log output file
// * 6) Try disabling a subset of tests by customizing bumblebee.properties and rerun
// * 
// * @author whoschek.AT.lbl.DOT.gov
// * @author $Author: hoschek3 $
// * @version $Revision: 1.7 $, $Date: 2004/10/26 16:43:38 $
// */
//public class BumblebeeAdapter implements Adapter {
//
//	private Document currentDoc;
//	
//	public BumblebeeAdapter() { 
//	}
//
//	/**       
//	 * Hint to load the specified file URI, as supplied by the        
//	 * !load directive in a test.       
//	 *        
//	 * @param uri The URI to load (e.g. tests/2003-05/examples/tunes.xml)       
//	 */      
//	public void load(String uri) throws AdapterException {
//		try {
//			currentDoc = BuilderPool.GLOBAL_POOL.getBuilder(false).build(new File(uri));
//		} catch (Exception e) {
//			throw new AdapterException("oopsla", e);
//		}
//	}
//
//	/**
//	 * Evaluates the specified XQuery expression against the XQuery engine run
//	 * by this adapter.
//	 * 
//	 * @param query
//	 *            The XQuery expression to evaluate.
//	 * @return The result of evaluating the XQuery expression. Note that the
//	 *         result must not include an XML declaration.
//	 * @throws AdapterException
//	 *             if the adapter cant evaluate the expression.
//	 */      
//	public String evaluate(String query) throws AdapterException {
//		StringBuffer buf = new StringBuffer();
//		Nodes nodes;
//		try {
//			XQuery xquery = new XQuery(query, null, null, getResolver());
//			nodes = xquery.execute(currentDoc).toNodes();
//		} catch (Exception e) {
//			throw new AdapterException("oopsla", e);
//		}
//		for (int k=0; k < nodes.size(); k++) {
//			Node node = nodes.get(k);
//			//String str = node.toXML();
//			String str = XOMUtil.toPrettyXML(node);
//			buf.append(str);
//		}
//		return buf.toString();
//	}
//	
//	private DocumentURIResolver getResolver() {
//		//if (true) return null;
//		return new DocumentURIResolver() {
//			public Document resolve(String href, String baseURI) throws ValidityException, ParsingException, IOException, TransformerException {
//				String systemID = new net.sf.saxon.StandardURIResolver().resolve(href, baseURI).getSystemId();
//				System.err.println("resolving systemID="+systemID);
//				return BuilderPool.GLOBAL_POOL.getBuilder(false).build(systemID);
//			}
//		};
//	}
//
//}
