package nux.xom.tests;

import nu.xom.Document;
import nu.xom.Element;
import nux.xom.binary.BinaryXMLCodec;

/**
 * Just to make sure our encoding/decoding implementation does not exhibit JDK's 16 MB bug
 * http://developer.java.sun.com/developer/bugParade/bugs/4949631.html
 */
class TestJDKCharsetBug {

	public static void main(String[] args) throws Exception {

		BinaryXMLCodec codec = new BinaryXMLCodec();
		
		int SIZE = 16 * 1024 * 1024;
		System.out.println("16 MB = "+ SIZE);
		
		for (int size=SIZE-40; size < SIZE+100; size++) {
			System.out.print("now at size = "+ size);
			char[] chars = new char[size];
			char c = 'x';
//			char c = 0x2000; // non-ASCII
			for (int i=0; i < size; i++) chars[i] = c;
			String str = new String(chars);
			Element root = new Element("root");
			root.appendChild(str);
			Document doc = new Document(root);
			byte[] bnux = codec.serialize(doc, 0);
			System.out.println(", byte[] bnux size = "+ bnux.length);
			Document doc2 = codec.deserialize(bnux);
			String str2 = doc2.getRootElement().getChild(0).getValue();
			
			if (!str.equals(str2)) throw new RuntimeException("JDK bug at size=" + size);
		}

		System.out.println("Done!\n\n");
	}
}